local function frontiershud(v, player)
        local inflives = CV_FindVar("cooplives")
		if G_IsSpecialStage() return end

		if player.mo and player.mo.valid
		and player.mo.skin == "modernknuckles" and player.khud == 4
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
						
			//Spinning ring
			v.draw(7,9,v.cachePatch("KFRRINGS"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			v.drawString(0, 25, "SCORE:", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			v.drawString(93, 25, player.score, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			//Ring count
			local numfont = "KFRNUM"
			local ringstring = tostring(player.rings)
			ringstring = string.format("%0".."3".."d", $1)
			
			for i = 1,ringstring:len() do
					v.draw(28+((i-1)*8),4,v.cachePatch(numfont..ringstring:sub(i,i)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
	                v.drawString(68,7, "/9999", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
								
			//Timer
			local posx = 160 //Offset so I can easily adjust
			local posy = 4
			local minutes = tostring(G_TicsToMinutes(player.realtime), true) // Minutes
			
			local newposx = (posx - ((minutes:len() - 1) * 8))
			for i = 1,minutes:len() do
				local readd = (i-1)*8
				v.draw(newposx+readd,posy,v.cachePatch(numfont..minutes:sub(i,i)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			v.draw(posx+8,4,v.cachePatch("KFRCOLON"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS) // :
			v.draw(137,4,v.cachePatch("KFRTIME"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			local seconds = tostring(G_TicsToSeconds(player.realtime)) // Seconds
			if (G_TicsToSeconds(player.realtime)) < 10
				v.draw(posx+17,4,v.cachePatch("KFRNUM0"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.draw(posx+25,4,v.cachePatch(numfont..seconds),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			else
				v.draw(posx+17,4,v.cachePatch(numfont..seconds:sub(1,1)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.draw(posx+25,4,v.cachePatch(numfont..seconds:sub(2,2)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			v.draw(posx+33,4,v.cachePatch("KFRCOLON"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS) // :
			
			local centi = tostring(G_TicsToCentiseconds(player.realtime)) // Centiseconds
			if (G_TicsToCentiseconds(player.realtime)) < 10
				v.draw(posx+42,4,v.cachePatch("KFRNUM0"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.draw(posx+50,4,v.cachePatch(numfont..centi),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			else
				v.draw(posx+42,4,v.cachePatch(numfont..centi:sub(1,1)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.draw(posx+50,4,v.cachePatch(numfont..centi:sub(2,2)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)				
			end
			
			//Lives count
			if not modeattacking
				local lifeicon = v.getSprite2Patch(player.mo.skin,SPR2_LIFE,(player.powers[pw_super] ~= 0),0,0)
				v.drawScaled(12*FRACUNIT,192*FRACUNIT,1*FRACUNIT,lifeicon,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS,v.getColormap(player.mo.skin, player.mo.color))
				
				if (player.lives > -1) and (player.lives < 127) and inflives.value != 0
					local livesstring = tostring(player.lives)
					local newposx = 32 - ((livesstring:len() - 1) * 8)
					for i = 1,livesstring:len() do
						local readd = (i-1)*8
						v.draw(newposx+readd,182,v.cachePatch(numfont..livesstring:sub(i,i)),V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					end
				end	
			
			
			if inflives.value == 0
						v.drawString(30, 182, "O", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(36, 182, "O", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					end
			end
			
		end // End of hud drawing, bye bye
		
end		
		
hud.add(frontiershud) // ok put it in the game now, pauly

local function hud_emercnt(v, player)
	local e = emeralds
	if player.mo.skin != "modernknuckles" or player.khud != 4 return end
	
	// wtf are these numbers :skull:
	if e == 0 then
		v.draw(270, 20, v.cachePatch("EMERCNT0"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 1 then
		v.draw(270, 20, v.cachePatch("EMERCNT1"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 3 then
		v.draw(270, 20, v.cachePatch("EMERCNT2"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 7 then
		v.draw(270, 20, v.cachePatch("EMERCNT3"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 15 then
		v.draw(270, 20, v.cachePatch("EMERCNT4"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 31 then
		v.draw(270, 20, v.cachePatch("EMERCNT5"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 63 then
		v.draw(270, 20, v.cachePatch("EMERCNT6"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
	if e == 127 then
		v.draw(270, 20, v.cachePatch("EMERCNT7"), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
	end
end
hud.add(hud_emercnt)

local function hud_speedofrontiers(v, player)
	//Speedometer
	if player.mo.skin != "modernknuckles" or player.khud != 4 return end
	if player.speed <= 1*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO1"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 2*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO2"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 4*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO3"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 8*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO4"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 12*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO5"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 15*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO6"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 21*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO7"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 25*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO8"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 30*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDO9"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 35*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOA"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 42*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOB"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 49*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOC"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 53*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOD"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
	elseif player.speed <= 60*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOE"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)	
	elseif player.speed <= 63*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOF"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)	
	elseif player.speed <= 66*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOG"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)	
	elseif player.speed <= 70*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOH"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)	
	elseif player.speed >= 70*FRACUNIT
		v.draw(260, 140, v.cachePatch("SPEEDOH"), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)	
	end
end
hud.add(hud_speedofrontiers)