freeslot("sfx_glide1", "sfx_glide2", "sfx_climb")
sfxinfo[sfx_glide1].caption = "Grasp"
sfxinfo[sfx_glide2].caption = "Wind blowing"
sfxinfo[sfx_climb].caption = "Climbing"
CV_RegisterVar({"knux_glidesounds", "On", CV_NETVAR, CV_OnOff})
addHook("MobjSpawn", function(mo) mo.glidesoundtimer = -1 end, MT_PLAYER)
addHook("MobjSpawn", function(mo) mo.climbsoundtimer = -1 end, MT_PLAYER)
addHook("MobjSpawn", function(mo) mo.isgliding = 0 end, MT_PLAYER)
addHook("PlayerThink", function(player)
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then return end
	local rouge_glidesounds = CV_FindVar("knux_glidesounds")
	if not rouge_glidesounds.value return end
	
	if player.mo.skin == "modernknuckles"
		if (player.pflags & PF_GLIDING)
		and not (player.mo.eflags & MFE_UNDERWATER)
		and not P_IsObjectOnGround(player.mo)
			player.mo.isgliding = 1	
			if player.mo.glidesoundtimer == -1 then
				S_StartSound(player.mo, sfx_glide1)
				player.mo.glidesoundtimer = 10
			elseif player.mo.glidesoundtimer == 0 then
				S_StartSound(player.mo, sfx_glide2)
				player.mo.glidesoundtimer = 87
			end
		elseif not (player.pflags & PF_GLIDING)
		or P_IsObjectOnGround(player.mo)
			player.mo.glidesoundtimer = -1
			if player.mo.isgliding == 1
				S_StopSoundByID(player.mo, sfx_glide2)
				player.mo.isgliding = 0
			end
		elseif player.climbing
		and player.mo.isgliding == 1
			player.mo.glidesoundtimer = -1
			S_StopSoundByID(player.mo, sfx_glide2)
			player.mo.isgliding = 0
		end
		if player.mo.glidesoundtimer > 0
			player.mo.glidesoundtimer = $1 - 1
		end
		if player.climbing
			if (player.cmd.forwardmove)
			or (player.cmd.sidemove)
				if player.mo.climbsoundtimer == -1 then
					S_StartSound(player.mo, sfx_climb)
					player.mo.climbsoundtimer = 8
				elseif player.mo.climbsoundtimer == 0 then
					S_StartSound(player.mo, sfx_climb)
					player.mo.climbsoundtimer = 8
				end
			end
		elseif not player.climbing
			player.mo.climbsoundtimer = -1
		end
		if player.mo.climbsoundtimer > 0
			player.mo.climbsoundtimer = $1 - 1
		end
	end
end)