freeslot("S_PLAY_HAMMERPUNCH")
states[S_PLAY_HAMMERPUNCH] = {SPR_PLAY, SPR2_FLY_1, 1, nil, 0, 0, S_PLAY_HAMMERPUNCH}

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook ("PlayerThink",function(player)
if player.mknuxhpunchcd == nil then player.mknuxhpunchcd = 0 return end
if player.mo.skin == "modernknuckles"
and not P_IsObjectOnGround(player.mo)
and not (player.pflags & PF_THOKKED)
and (player.cmd.buttons & BT_CUSTOM1) and not (player.cmd.buttons & BT_CUSTOM3)  and not (player.cmd.buttons & BT_CUSTOM2)
and not player.mkcd1
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and player.mo.state != S_PLAY_PUNCH1
and player.mo.state != S_PLAY_ALTPUNCH1
and player.mo.state != S_PLAY_PUNCHWAIT
and player.mo.state != S_PLAY_PUNCH2
and player.mo.state != S_PLAY_ALTPUNCH2
and player.mo.state != S_PLAY_CLIMB
and player.mo.state != S_PLAY_CLING
and not player.actionstate
and not player.digland
and not (player.pflags & PF_SLIDING)
and not player.guard
and not player.airdodge

S_StartSound(player.mo, sfx_zoom)
S_StartSound(player.mo, sfx_kvc4)
P_SetObjectMomZ(player.mo,-45*FRACUNIT,true)
player.pflags = $|PF_JUMPED
player.pflags = $|PF_THOKKED
player.hampunch = true
player.mo.state = S_PLAY_HAMMERPUNCH
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.hampunch
and P_IsObjectInGoop(player.mo)

player.hampunch = false
player.mkcd1 = true
end
end)

addHook ("PlayerThink",function(player)
local mo = player.mo
if mo.skin == "modernknuckles"
and player.hampunch
and P_IsObjectOnGround(mo)

player.hampunch = false
P_NukeEnemies(mo,mo,150*FRACUNIT)
mo.state = S_PLAY_GLIDE_LANDING
player.mkcd1 = true
CheckAndCrumble(mo, mo.subsector.sector)
end
end)

addHook("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.powers[pw_justsprung]
and player.hampunch

S_StartSound(mobj, sfx_sprong)
player.mo.state = S_PLAY_SPRING
player.hampunch = false
player.powers[pw_justsprung] = 0
P_SetObjectMomZ(player.mo,5*FRACUNIT,true)
player.mkcd1 = true
end
end)

addHook("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and player.hampunch

player.hampunch = false
player.mkcd1 = true
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.mkcd1
and not (leveltime%35)

player.mknuxhpunchcd = $+1
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.mkcd1
and player.mknuxhpunchcd == 6

player.mknuxhpunchcd = 0
player.mkcd1 = false
S_StartSound(player.mo, sfx_s3k8c)
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "modernknuckles"
and player.hampunch
and (player.mo.momz > (9000*P_MobjFlip(player.mo)))
				
P_SetObjectMomZ(player.mo, FixedMul(-55*FRACUNIT, player.mo.scale))
end
end)